﻿using BaseApplicationProject.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace BaseApplicationProject
{
    public class CarsGraphSource : SerializableGraphSourceBase<NodeViewModelBase, Link>
    {
        public CarsGraphSource()
        {
            Brand vwGroup = new Brand() { Content = "Volkswagen Group", Position = new Point(250, 100) };

            Model continental = new Model() { Content = "Continental GT", Position = new Point(250, 100) };
            Model veyron = new Model() { Content = "Bugatti Veyron", Position = new Point(475, 100) };
            vwGroup.AddItem(continental);
            vwGroup.AddItem(veyron);

            this.AddNode(vwGroup);
        }

        public override object CreateNode(IShape shape)
        {
            var newItem = base.CreateNode(shape);
            if (shape.Content != null)
                (newItem as NodeViewModelBase).Content = shape.Content;

            return newItem;
        }

        public override NodeViewModelBase DeserializeNode(IShape shape, Telerik.Windows.Diagrams.Core.SerializationInfo info)
        {
            NodeViewModelBase node = null;
            if (shape is IContainerShape)
            {
                node = new Brand();
            }
            else
            {
                node = new Model();
            }
            if (info["Content"] != null)
                node.Content = info["Content"].ToString();
            if (info[this.NodeUniqueIdKey] != null)
            {
                var nodeUniquekey = info[this.NodeUniqueIdKey].ToString();
                this.CachedNodes[nodeUniquekey] = node;
            }

            return node;
        }

        public override string GetNodeUniqueId(NodeViewModelBase node)
        {
            if (node != null)
                return node.GetHashCode().ToString();

            return string.Empty;
        }
    }
}
